import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;


public class StatistikaVykonnosti {
	private Map<Vcela, Integer> statistika = new HashMap<Vcela, Integer>();
	
	private int celkovyPel;
	
	/**
	 * Zaeviduje pel, ktory vcela prave nesie, do statistiky. Pel sa vsak nevynuluje!
	 */
	public void zaeviduj(Vcela vcela) {
		celkovyPel = celkovyPel + vcela.getNesenaDavka();
		
		if(!statistika.containsKey(vcela)) {
			statistika.put(vcela, vcela.getNesenaDavka());
			return;
		}
		Integer aktualnaStatistika = statistika.get(vcela);
		int novaStatistika = aktualnaStatistika + vcela.getNesenaDavka();
		statistika.put(vcela, novaStatistika);
		
		
	}
	
	public int odoberPel(int davka) {
		if(davka > celkovyPel) {
			davka = celkovyPel;
		}
		celkovyPel = celkovyPel - davka;
		return davka;
	}
	
	public int getCelkovyPel() {
		return celkovyPel;
	}
	
	public String getPodrobnaStatistika() {
		StringBuilder sb = new StringBuilder();
		sb.append("---------------\n");
		for (Entry<Vcela, Integer> entry : statistika.entrySet()) {
			sb.append("Vcela " + entry.getKey() + "  --  " + entry.getValue() + "\n");
		}
		sb.append("---------------\n");
		
		return sb.toString();
	}
}
