import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;


public class Ul {
	private Map<Vcela, Komorka> bydliska = new HashMap<Vcela, Komorka>();
	
	private StatistikaVykonnosti statistika = new StatistikaVykonnosti();
	
	private Luka lka;
	
	public Ul(Luka lka) {
		this.lka = lka;
	}

	public List<Vcela> getObyvateliaKomorky(Komorka komorka) {
		List<Vcela> obyvatelia = new ArrayList<Vcela>();
		
		for (Entry<Vcela, Komorka> e : bydliska.entrySet()) {
			if(e.getValue().equals(komorka)) {
				obyvatelia.add(e.getKey());
			}
		}
		return obyvatelia;
	}
	
	public Komorka getBydlisko(Vcela vcela) {
		return bydliska.get(vcela);
	}
	
	public void pridajVcelu(Vcela v) {
		if(v == null) {
			throw new NullPointerException("Nemozno pridat null vcelu do ula!");
		}
		
		Komorka komorka = new Komorka();
		bydliska.put(v, komorka);
		v.setUl(this);
		
		System.out.printf("Do ula sa pridala vcela %s typu %s\n", v, v.getClass());
	}
	
	public void prestahujVcelu(Vcela vcela, Komorka noveBydlisko) {
		bydliska.put(vcela, noveBydlisko);
	}
	
	public void pristanSPelom(Vcela vcela) {
		System.out.printf("Vcela %s pristala v uli s davkou %s\n", vcela.getMeno(), vcela.getNesenaDavka());
		statistika.zaeviduj(vcela);
		Komorka noveBydlisko = new Komorka();
		prestahujVcelu(vcela, noveBydlisko);
	}
	
	protected void zozerPel(int mnozstvo) {
		statistika.odoberPel(mnozstvo);
		System.out.printf("Z ula bol zozray pel %s\n", mnozstvo);
	}
	
	public Luka getLka() {
		return lka;
	}
	
	public void setLka(Luka lka) {
		this.lka = lka;
	}
	
	public void spustiPracuVciel() {
		List<Vcela> vcely = new ArrayList<Vcela>(bydliska.keySet());
		for (Vcela vcela : vcely) {
			vcela.pracuj();
		}
		vypisStatistiku();
	}
	
	private void vypisStatistiku() {
		System.out.println(statistika.getPodrobnaStatistika());
	}

	public Vcela nagenerujVcelu() {
		// TODO strasna zavislost
		int druhVcela = Utils.dajNhodnslo(1, 3);
		Vcela novaVcela = null;
		switch (druhVcela) {
		case 1:
			novaVcela = new Robotnica(this);
			break;
		case 2:
			novaVcela = new Trud(this);
			break;
		case 3:
			novaVcela = new Kralovna(this);
			break;
		}
		pridajVcelu(novaVcela);
		
		return novaVcela;
	}
	
}
