import java.util.UUID;


public abstract class Vcela {
	private String meno;
	
	private int kapacita;

	private int nesenaDavka;
	
	private Ul ul;
	
	public Vcela(Ul ul) {
		this(ul, UUID.randomUUID().toString(), Utils.dajNhodnslo(1, 3));
	}
	
	public Vcela(Ul ul, String meno, int kapacita) {
		this.meno = meno;
		this.kapacita = kapacita;
	}

	public abstract void pracuj();

	public String getMeno() {
		return meno;
	}

	public void setMeno(String meno) {
		this.meno = meno;
	}

	public int getKapacita() {
		return kapacita;
	}

	public void setKapacita(int kapacita) {
		this.kapacita = kapacita;
	}
	
	public int getNesenaDavka() {
		return nesenaDavka;
	}
	
	public void setNesenaDavka(int nesenaDavka) {
		this.nesenaDavka = nesenaDavka;
	}

	public Ul getUl() {
		return ul;
	}
	
	public void setUl(Ul ul) {
		this.ul = ul;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + kapacita;
		result = prime * result + ((meno == null) ? 0 : meno.hashCode());
		result = prime * result + nesenaDavka;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Vcela other = (Vcela) obj;
		if (kapacita != other.kapacita)
			return false;
		if (meno == null) {
			if (other.meno != null)
				return false;
		} else if (!meno.equals(other.meno))
			return false;
		if (nesenaDavka != other.nesenaDavka)
			return false;
		return true;
	}
	
	
}
